	DEVICE ZXSPECTRUM128

	MACRO dbw bt,wr
	 db bt
	 dw wr
	ENDM
	
	org 0x615e,0
	
start	jp intro
intupt	push af,bc,de,hl
	exx
	exa
	push af,bc,de,hl,ix,iy
	
aniFlag	scf
	call nc,playani
	
	pop iy,ix,hl,de,bc,af
	exx
	exa
	pop hl,de,bc,af
	ei
	ret

anim	incbin "cat2.ani"
	include	"aniplay.asm"

intro	di
	ld hl,0x6000
	ld de,0x6001
	ld bc,0x100
	ld a,h
	ld i,a
	inc a
	ld (hl),a
	ldir
	im 2
	
	ld hl,0x4000
	ld de,0x4001
	ld bc,0x1800
	ld (hl),l
	ldir
	ld bc,0x2ff
	ld (hl),7
	ldir
	xor a
	out (0xfe),a
		
	ei

	ld de,0x5080
	ld hl,inTxtDN
	call prnText

	ld de,0x5018
	ld hl,anim
	call initani
	ld a,0xa7
	ld (aniFlag),a
	
	ld hl,iScript
intr01	ld a,(hl)
	and a
	jr z,wex01
	ld b,a
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	call waitB
	jr nz,waitEx
	push hl
	ex de,hl
	call txSlide
	pop hl
	jr intr01
waitEx	ld hl,inTxtEN
	call txSlide
wex01	call waitKey
	call noKey
	di
	ld a,0x3f
	ld i,a
	im 1
	ei
	
	call cls
	
	ret

waitKey	xor a
	in a,(0xfe)
	cpl
	and 31
	jr z,waitKey
	ret

noKey	xor a
	in a,(0xfe)
	cpl
	and 31
	jr nz,noKey
	ret

waitB	halt
	xor a
	in a,(254)
	cpl
	and 31
	ret nz
	djnz waitB
	xor a
	ret

prnText	;dbgstop
	ld a,(hl)
	sub 32
	ret c
	call prtChar
	inc hl
	jr prnText

prtChar	push hl
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fntx1
	add hl,bc
	ld b,8
	ld c,d
prt2	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	djnz prt2
	ld d,c
	pop hl
	inc e
	ret
	
txSlide	ld de,0x481f
txs01	halt
	push de
	push hl
txs02	ld a,(hl)
	sub 32
	jr c,txsES
	call prtChar
	inc hl
	ld a,e
	and 0x1f
	jr nz,txs02
txsES	pop hl
	pop de
	dec e
	ld a,e
	inc a
	and 0x1f
	jr nz,txs01
	ret

cls	ld b,8
cls0	halt
	ld hl,0x5800
cls1	ld a,(hl)
	and 7
	jr z,cls2
	dec (hl)
cls2	ld a,(hl)
	and 0x38
	jr z,cls3
	ld a,(hl)
	sub 8
	ld (hl),a
cls3	inc hl
	ld a,h
	cp 0x5b
	jr c,cls1
	djnz cls0
	ld hl,0x4000
	ld de,0x4001
	ld bc,0x1800
	ld (hl),l
	ldir
	ld bc,0x2ff
	ld (hl),l
	ldir
	ret

;	    0123456789abcdef0123456789abcdef
inTxt01	db "What do you waiting for?        ",0
inTxt02	db "No intro here                   ",0
inTxt03	db "Just look at this cat           ",0
inTxt04	db "Cute, isn't it?                 ",0
inTxt05	db "Whatever...                     ",0
inTxtEN	db "Press any key                   ",0

inTxtDN	db "sam style                       "
	db "sand/mayHem                     "
	db "nq/skrju                        "
	db "         (c) 2013,2014",0

iScript	dbw 250,inTxt01
	dbw 200,inTxt02
	dbw 200,inTxt03
	dbw 200,inTxt04
	dbw 200,inTxt05
	dbw 200,inTxtEN
	db 0

fntx1	incbin "../bin/font x1.bin"

	SAVESNA "intro.sna",start
;	SAVEBIN "intro.bin",start,$-start