	DEVICE ZXSPECTRUM128

; Comment or uncomment DEFINEs for switch some features
;	DEFINE Debug		; this is debug build (editor, switch levels...)

	MACRO dbw bte,wrd
	db bte
	dw wrd
	ENDM

	MACRO dbbw b1,b2,wr
	db b1,b2
	dw wr
	ENDM

	MACRO db3w b1,b2,b3,wr
	db b1,b2,b3
	dw wr
	ENDM
	
	MACRO border col
	ld a,col
	out (0xfe),a
	ENDM

	MACRO dbgstop
	jr $
	ENDM
	
	MACRO toatr reg
	ld a,reg
	rra
	rra
	rra
	and 3
	or 0x78
	ld reg,a
	ENDM
	
maxlev	DEFL 25
muzBank	DEFL 1

	ORG 0xe000,0
bgrScr	incbin "bin/background.scr"

	org 0xc000,muzBank
player	include "pt3xplayer.asm"
gamMuz	incbin "muz/nq-ninja-ingame.pt3"
menMuz	incbin "muz/nq-ninja-menu.pt3"
lcomMuz	incbin "muz/nq-ninja_level_completed.pt3"
failMuz incbin "muz/nq-ninja_level_failed.pt3"
muzSize=$-0xc000

	ORG 0x817e,0
	
	jp start
i8181	push af
	push bc
	push de
	push hl
	exx
	exa
	push af
	push bc
	push de
	push hl
	push ix
	push iy
	
srlFlag	scf
	call nc,doScrl
;	border 1
usFlag	scf
	call nc,updScr
;	border 0
	call animAll

	call playMuz

	pop iy
	pop ix
	pop hl
	pop de
	pop bc
	pop af
	exx
	exa
	pop hl
	pop de
	pop bc
	pop af
	ei
	ret

	include "smpplay.asm"

bank	push bc
	and 7
	ld (curBank),a
	or 0x10
	ld bc,0x7ffd
	out (c),a
	pop bc
	ret

curBank	db 0

	include "muzik.asm"

usOn	ld a,0xa7
	jr usof1
usOff	ld a,0x37
usof1	ld (usFlag),a
	xor a
	ld (0x7b00),a
	ld (0x7b01),a
	ret
	
nmOn	ld a,0xa7
	ld (nmFlag),a
	ret
nmOff	ld a,0x37
	ld (nmFlag),a
	ret

animAll
nmFlag	scf
	ret c
;	border 3
animFor	call hideBox		; hide
;	border 4
	call RestBgr1
	call RestBgr2	
;	border 5
	call blkAnim
;	border 4
	call ninMove
;	border 5
	call animBox
;	border 6
	call SaveBgr2
	call DrawNin2
	call SaveBgr1
	call DrawNin1
;	border 7
	call showBox		; show
	ret

chAdr	dw 0x7b00

updBC1	push bc		; add 1 box (bc as coord)
	push de
	push hl
	call bc2scr
	call addUpd1
	pop hl
	pop de
	pop bc
	ret

updBC	and a
	ret c
	call bc2scr	; add 2x2 block (bc as coord)
	jr addUpd

addUpd1	push de		; add 1 box (hl as scr.adr)
	push hl
	ex de,hl
	ld a,d
	and 0x18
	or 0x40
	ld d,a
	ld hl,(chAdr)
	jr adu_l
addUpd	push de		; add 2x2 box (hl as scr.adr)
	push hl
	ex de,hl
	ld a,d
	and 0x18
	or 0x40
	ld d,a
	ld hl,(chAdr)
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	inc e
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	dec e
adu_l	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ld (chAdr),hl
	xor a
	ld (hl),a
	inc hl
	ld (hl),a
	pop hl
	pop de
	ret

updScr	ld hl,0x7b00
	ld (chAdr),hl
ires_1	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,d
	or e
	jr z,ires_e
	push hl
	ld a,d
	or 0x20
	ld b,a
	ld c,e
ires_3	ld a,(bc)
	ld (de),a
	inc d
	inc b
	ld a,d
	and 7
	jr nz,ires_3
	ld a,d
	dec a
	rra
	rra
	rra
	and 3
	or 0x58
	ld d,a
	or 0x20
	ld b,a
	ld c,e
	ld a,(bc)
	ld (de),a
	pop hl
	jr ires_1
ires_e	ld hl,0
	ld (0x7b00),hl
	ret
	
start	di
	ld hl,0x8000
	ld de,0x8001
	ld bc,0x100
	ld a,h
	ld i,a
	inc a
	ld (hl),a
	ldir
	im 2
	xor a
	ld hl,0x7b00
	ld (chAdr),hl
	ld (hl),a
	inc hl
	ld (hl),a

	xor a
	call bank

	ei
mainTS	call doMenu
	call passKey

;	xor a
;	call setMuz

mainNew	
	call cartoon
	xor a		; in-game muz
	call setMuz
	call btwLev	; picture between levels
	call noKey
	call waitKey
	call noKey

mainGo	call dbgLevC	; set current level

;	ld a,12
;	call setSFX

main_1	halt		; start game loop

	call mvCloud

	ld hl,MainInpAll
	call InKeys

	ld hl,(nin1x)	; test ninjas collison
	ld de,(nin2x)
	and a
	sbc hl,de
	ld a,h
	or l
	jr nz,main_2
	ld a,6
	call setSFX
	ld a,3
	ld (levEnd),a
main_2	ld a,(nin1dir)	; is ninjas or blocks moving now?
	ld c,a
	ld a,(nin2dir)
	or c
	ld c,a
	ld a,(movcnt)
	or c
	jr nz,main_1
	call testBM	; is pieces moving now?
	jr nz,main_1
	ld a,(levEnd)	; is level failed/completed?
	and a
	jr nz,mainLE
	ld a,(ninmovz)	; if ninjas was moved, decrease turns - FAIL if zero
	and a
	call nz,ninTurn
	ld hl,levFail
	jr c,mainLF
mainA	halt
	call mvCloud
	xor a
	in a,(0xfe)
	cpl
	and 31
	jr nz,mainA
	ld (ninmovz),a
	jr main_4
main_3	halt
	call mvCloud
main_4	ld hl,MainInp
	call InKeys
	jr z,main_3
	jr main_1

mainLE	; dbgstop
	ld b,25
mle1	halt
	djnz mle1
	dec a
	jr z,mainLS
mainLF	ld a,3		; fail muz
	call setMuz
	ld hl,levFail
	halt
	call nmOff
	call usOff
	call outText
	call noKey
	call waitKey
	call noKey
	xor a		; in-game muz
	call setMuz
	jp mainGo

mainLS	ld a,2		; level completed muz
	call setMuz
	ld hl,levComp	; succes
	ld a,(curLev)
	inc a
	ld (curLev),a
	cp maxlev
	jr nc,gameCmp
	halt
	call nmOff
	call usOff
	call outText
	call outCode
	call noKey
	call waitKey
	call noKey
	jp mainNew

gameCmp	ld hl,gamComp	; game completed
	call nmOff
	call usOff
	call outText
	call noKey
	call waitKey
	call noKey
	call cartoon
	call doFinal	; game completed
	call nmOff
	call usOff
	ld b,200
gcmp1	halt
	xor a
	in a,(254)
	cpl
	and 31
	jr nz,gcmp2
	djnz gcmp1
gcmp2	call noKey
	jp mainTS

btwLev	call cls
	ld de,0x5800
	ld hl,btwTab
blv1	ld a,(hl)
	inc hl
	ld c,(hl)
	inc hl
	and a
	jr z,blvTXT
	ld b,a
	ld a,c
blv2	ld (de),a
	inc de
	djnz blv2
	jr blv1
blvTXT	ld a,r
	and 31
	add a,a
	ld hl,bltTab
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	push hl
	ld c,0xff
blvt1	inc c
	ld a,(hl)
	inc hl
	and a
	jr nz,blvt1
	pop hl
	ld a,32
	sub c
	rra
	and 15
	or 0xe0
	ld e,a
	ld d,0x50
	call prnText
	ld hl,0x5ae0
	ld a,0x17
blvt2	ld (hl),a
	inc l
	jr nz,blvt2
	ret

bltTab	dw bltx00,bltx01,bltx02,bltx03
	dw bltx04,bltx05,bltx06,bltx07
	dw bltx08,bltx09,bltx10,bltx11
	dw bltx12,bltx13,bltx14,bltx15
	dw bltx16,bltx17,bltx18,bltx19
	dw bltx20,bltx21,bltx22,bltx23
	dw bltx24,bltx25,bltx26,bltx27
	dw bltx28,bltx29,bltx30,bltx31

bltx00	db "ninja is invisible",0
bltx01	db "ninja ripe heads, not fruits",0
bltx02	db "ninja can touch the sky",0
bltx03	db "try to find another ninja here",0
bltx04	db "who's here?",0
bltx05	db "i'm watching you",0
bltx06	db "don't open a black door",0
bltx07	db "ninja is a brick in the wall",0
bltx08	db "pretty fly for a ninja guy",0
bltx09	db "one two ninja comming for you",0
bltx10	db "three four close up your door",0
bltx11	db "what for do you read this?",0
bltx12	db "kiiiiiiiiya, they said",0
bltx13	db "it's ninja-man, halleluja",0
bltx14	db "you can't see ninjas",0
bltx15	db "ninja touch make you dead",0
bltx16	db "prototype is NINJA TWINS game",0
bltx17	db "don't look back, ninja there",0
bltx18	db "ninja kill my hamster",0
bltx19	db "ninja kill Kennedy",0
bltx20	db "ninja was first man on Mars",0
bltx21	db "Houston we have a problems",0
bltx22	db "ninja can eat an elephant",0
bltx23	db "i'm afraid of ninja ghost",0
bltx24	db "ninja don't need to breath",0
bltx25	db "even blind ninja can kill you",0
bltx26	db "ninja can see you right now",0
bltx27	db 35," ninjas ",35," is everywhere ",35,0
bltx28	db "cake is lie",0
bltx29	db "game creators are ninjas too",0
bltx30	db "ninja hate hamsters",0
bltx31	db "ninja already know your name",0

btwTab	db 132,0x00,24,0x3f
	db 8,0x00,24,0x3f
	db 8,0x00,2,0x3f,2,0x00,16,0x3f,2,0x00,2,0x3f
	db 8,0x00,2,0x3f,2,0x00,16,0x3f,2,0x00,2,0x3f
	db 8,0x00,4,0x3f,4,0x00,08,0x3f,4,0x00,4,0x3f
	db 8,0x00,4,0x3f,4,0x00,08,0x3f,4,0x00,4,0x3f
	db 10,0x00,4,0x3f,4,0x00,4,0x3f,4,0x00,4,0x3f
	db 12,0x00,4,0x3f,4,0x00,4,0x3f,4,0x00,4,0x3f
	db 14,0x00,16,0x3f
	db 16,0x00,16,0x3f
	db 0

cls	ld b,8
cls0	halt
	ld hl,0x5800
cls1	ld a,(hl)
	and 7
	jr z,cls2
	dec (hl)
cls2	ld a,(hl)
	and 0x38
	jr z,cls3
	ld a,(hl)
	sub 8
	ld (hl),a
cls3	inc hl
	ld a,h
	cp 0x5b
	jr c,cls1
	djnz cls0
	ld hl,0x4000
	ld de,0x4001
	ld bc,0x1800
	ld (hl),l
	ldir
	ld bc,0x2ff
	ld (hl),l
	ldir
	ret

waitKey	xor a
	in a,(0xfe)
	cpl
	and 31
	jr z,waitKey
	ret

noKey	xor a
	in a,(0xfe)
	cpl
	and 31
	jr nz,noKey
	ret

InKeys	ld a,(hl)
	and a
	ret z
	inc hl
	in a,(0xfe)
	and (hl)
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	jr nz,InKeys
	ex de,hl
callHL	jp (hl)

MainInpAll
	; dw 0x10bf,gameH		; H:halt
	dw 0x08fb,gameR		; R:reset
	db 0

MainInp	dw 0x01fd,movDown	; A
	dw 0x01fb,movUp		; Q
	dw 0x01df,movRight	; P
	dw 0x02df,movLeft	; O
	
	dw 0x10ef,movLeft	; 6
	dw 0x08ef,movRight	; 7
	dw 0x04ef,movDown	; 8
	dw 0x02ef,movUp		; 9
	
	dw 0x10bf,gameH		; H:menu
	dw 0x08fb,gameR		; R:reset
	dw 0x047f,gameM		; M:muz switch
	dw 0x08fe,gameC		; C:switch parallax
	dw 0x08fd,gameF		; F:switch sfx

	IFDEF Debug
	 dw 0x04fb,doEdit	; E:editor
	 dw 0x01f7,levDown	; 1,2:switch levels
	 dw 0x02f7,levUp
	ENDIF
	db 0

gameF	call sfxSw		; F:sfx switch
	jr gamm01
	
gameC	call prlxSw		; C:parallax switch
	jr gamm01
	
gameM	call muzSw		; M:muzic switch
gamm01	halt
	call mvCloud
	xor a
	in a,(254)
	cpl
	and 31
	jr nz,gamm01
	xor a
	ret

gameR	call nmOff		; R:reset level
	ld hl,resText
	call outText
	call noKey
gamr1	halt
	ld hl,resKey
	call InKeys
	jr gamr1

resText	db "RESET? Y/N",0

resKey	dw 0x10df,rkeyY
	dw 0x087f,hkeyN
	db 0

rkeyY	pop af	; rkey Y
	pop af	; game R
	call noKey
	jp mainGo

gameH	call nmOff		; H:quit to menu
	call gamenu;
	jp nmOn
;	ld hl,quiText
;	call outText
;	call noKey
;gamh1	halt
;	ld hl,haltKey
;	call InKeys
;	jr gamh1

/*
quiText	db "QUIT? Y/N",0

haltKey	dw 0x10df,hkeyY
	dw 0x087f,hkeyN
	db 0
	
hkeyY	pop af		; halt N
	pop af		; game H
	call usOff
	call noKey
	call cls
	jp mainTS
*/

hkeyN	pop af		; halt N
	call noKey
	ld hl,0x4000
	ld de,0x6000
	ld bc,0x800
	ldir
	ld hl,0x6800
	ld de,0x4800
	ld bc,0x800
	ldir
	ld hl,0x7900
	ld de,0x5900
	ld bc,0x100
	ldir
	call nmOn
	xor a
	ret

; debug

	IFDEF Debug
	
levDown	ld a,(curLev)
	sub 1
	jr nc,lup1
	ld a,maxlev-1
	jr lup1
levUp	ld a,(curLev)
	inc a
	cp maxlev
	jr c,lup1
	xor a
lup1	ld (curLev),a
	
	ENDIF
	
dbgLevC	call nmOff
	ld a,(curLev)
	call SetLev
	call noKey
	call nmOn
	jp usOn

; end debug

; decrease turn
; NC:not zero
; C:zero, end of level
ninTurn	;dbgstop
	ld a,(turn)
	dec a
	ld (turn),a
	call drwTurn
	ld a,(turn)
	and a
	ret nz
	scf
	ret

movUp	ld a,1
	jr movNin
movRight	ld a,2
	jr movNin
movDown	ld a,3
	jr movNin
movLeft	ld a,4
movNin	ld (nin1dir),a
	ld (nin2dir),a
	ld e,a
	ld bc,(nin1x)	; check box on head
	call ninHead
	ld bc,(nin2x)
	call ninHead
	ld a,9
	call setSFX
toRet	or 2
	ret

map2bc	ld bc,levBuf
	and a
	sbc hl,bc
	ld a,l
	and 0x0f
	rla
	ld c,a
	ld a,l
	and 0xf0
	rra
	rra
	rra
	ld b,a
	ret

bc2map	ld a,b
	rlca
	rlca
	rlca
	and 0xf0
	ld h,a
	ld a,c
	rrca
	and 0x0f
	or h
	ld hl,levBuf
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ret

bc2scr	ld a,b
	rrca
	rrca
	rrca
	and 0xe0
	or c
	ld l,a
	ld a,b
	and 0x18
	or 0x60
	ld h,a
	ret

	include "ninjas.asm"
	include "map.asm"
	include "print.asm"
	include "menu.asm"
	include "password.asm"
	include "cartoon.asm"
	include "finalcut.asm"
	include "dehrust_ix.asm"
	include "clouds.asm"

	IFDEF Debug
	 include "editor.asm"
	ENDIF
	
intcnt	db 0
	
curLev	db 0
levEnd	db 0
ninmovz	db 0

; anim	+0 count (0:anim stop)
;	+1,2	X,Y on screen
;	+3,4	anim adr
aniTab	ds 5 * 32
	db 0

sprGfx	incbin "bin/sprites.bin"

levBuf	ds 176			; map 16 x 11
nin1x	db 0			; x,y 1st ninja (1x1 boxes)
nin1y	db 0
nin2x	db 0			; x,y 2nd ninja
nin2y	db 0
nin1dir	db 0			; 1,2,3,4 = up,rg,dn,lf
nin2dir	db 0			; direction of ninja moving
nin1spr	db 0			; ninja sprites nr
nin2spr	db 0
movcnt	db 0			; count of moving blocks
turn	db 1			; turns to complete level
infsize=($-nin1x)
levsize=88+infsize

nin1bgr	ds 76
nin2bgr	ds 76

lev000	incbin "bin/ninlevs.bin"

	display "end @ ",$,": 0xE000"

	display "--- compilation flags:"

	IFDEF Debug
	 display "+ Debug"
	ELSE
	 display "- Debug"
	ENDIF
; snapshot
	SAVESNA "snap.sna",start
; binary files
;	PAGE 0
;	SAVEBIN "out/main-817E-0.bin",0x817e,$-0x817e
;	SAVEBIN "out/bgr-E000-0.bin",0xe000,0x1b00
;	PAGE muzBank
;	SAVEBIN "out/muzic-C000-1.bin",0xc000,muzSize
