FillFld	ld de,0x6000
ffldDE	ld hl,bgrScr
	ld bc,0x1b00
	ldir
	xor a
	out (0xfe),a
	ret

getLAdr	push de
	ld de,levsize
	ld hl,lev000
	and a
	jr z,gladE
glad1	add hl,de
	dec a
	jr nz,glad1
gladE	pop de
	ret

popLev	ld hl,updBC
	ld (hl),0x37
	call getLAdr
	ld de,levBuf
	ld b,88
slv_P	ld a,(hl)
	rra
	rra
	rra
	rra
	and 0x0f
	ld (de),a
	inc de
	ld a,(hl)
	and 0x0f
	ld (de),a
	inc de
	inc hl
	djnz slv_P
	ld bc,infsize
	ldir
strOn	ld a,0xa7
	ld (updBC),a
	ret
strOff	ld a,0x37
	ld (updBC),a
	ret
	
SetLev	call popLev
	call usOff	; off screen updater
	call nmOff
	xor a
	ld (levEnd),a
	ld (ninmovz),a
	ld hl,aniTab	; reset field animation
	ld de,5
	ld b,32
slv_1	ld (hl),0
	add hl,de
	djnz slv_1
	ld hl,boxTab	; reset boxes animation
	ld b,32
slv_2	ld (hl),0
	add hl,de
	djnz slv_2
	call FillFld
	call DrawFld
	call SaveBgr2
	call DrawNin2
	call SaveBgr1
	call DrawNin1
	ld hl,levText
	ld de,0x70e1
	call prnText
	call dropScr
	call drwTurn
	jp usOn

drwTurn	ld hl,0x50d0
	ld a,(turn)
dtrnCYC	cp 2
	jr c,dtrnLST
	ld c,0x77
	call dtrnSR
	sub 2
	jr dtrnCYC
dtrnLST	ld c,0x70
	and a
	jr nz,dtrnSR
	ld c,0x00
dtrnSR	exa
	ld b,8
	ld e,h
dtsr1	ld (hl),c
	inc h
	djnz dtsr1
	ld h,e
	inc l
	exa
	ret

dropScr	call cls
	ld hl,0x6000
	ld de,0x4000
	ld bc,0x1800
	ldir
	ld b,8
dscr1	halt
	ld hl,0x5800
	ld de,0x7800
dscr2	ld a,(de)
	xor (hl)
	and 7
	jr z,dscr3
	inc (hl)
dscr3	ld a,(de)
	xor (hl)
	and 0x38
	jr z,dscr4
	ld a,(hl)
	add a,8
	ld (hl),a
dscr4	inc hl
	inc de
	ld a,h
	cp 0x5b
	jr c,dscr2
	djnz dscr1
	ld hl,0x7800
	ld de,0x5800
	ld bc,0x300
	ldir
	ret

DrawFld	ld de,0x6000
dfldDE	ld hl,levBuf
	ld b,11
dfld_1	ld c,16
	push de
dfld_2	push bc
	push de
	push hl
	ld a,(hl)
	and a
	jr z,dfld_2a
;	cp 12
;	jr nz,dfld_2z
;	push de
;	call map2bc
;	ld de,tlpAni
;	call addAni
;	pop de
dfld_2z	call DrawBox
dfld_2a	pop hl
	pop de
	pop bc
	inc hl
	inc e
	inc e
	dec c
	jr nz,dfld_2
	pop de
	ld a,e
	add a,64
	ld e,a
	jr nc,dfld_3
	ld a,d
	add a,8
	ld d,a
dfld_3	djnz dfld_1
	ret

; draw sprite A on scr.addr DE (A=0 - restore background)
DrawBox	
	exa
	ld l,e
	ld h,d
	call addUpd
	exa
dboxIN
	IFDEF Debug
	 ld (boxNum),a
	ENDIF
	and a
	jr z,dboxE
dboxNZ	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld c,l
	ld b,h
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,sprGfx
	add hl,bc
	ld b,2
	push de
dbox_1	ld c,8
dbox_2	ld a,(hl)
	ld (de),a
	inc hl
	inc e
	ld a,(hl)
	ld (de),a
	inc hl
	dec e
	inc d
	dec c
	jr nz,dbox_2
	ld a,e
	add a,32
	ld e,a
	jr c,dbox_3
	ld a,d
	sub 8
	ld d,a
dbox_3	djnz dbox_1
	pop de
	ld a,d
	and 0xe0
	or 0x18
	ld c,a
	ld a,d
	rra
	rra
	rra
	and 3
	or c
	ld d,a
	
	IFDEF Debug
	 ld a,0
boxNum	 equ $-1
	 cp 13
	 jr z,boxRed
	 cp 14
	 jr z,boxRed
	ENDIF
	
	ldi
	ldi
	ld a,e
	add a,30
	ld e,a
	adc a,d
	sub e
	ld d,a
	ldi
	ldi
	ret
	IFDEF Debug
boxRed	ld a,2
	ld (de),a
	inc e
	ld (de),a
	ld a,e
	add a,31
	ld e,a
	adc a,d
	sub e
	ld d,a
	ld a,2
	ld (de),a
	inc de
	ld (de),a
	ret
	ENDIF
dboxE	ld a,d
	and 0x18
	or (bgrScr / 256)
	ld h,a
	ld l,e
	push de
	ld b,2
dbe_1	ld a,(hl)
	ld (de),a
	inc l
	inc e
	ld a,(hl)
	ld (de),a
	inc h
	inc d
	ld a,(hl)
	ld (de),a
	dec l
	dec e
	ld a,(hl)
	ld (de),a
	inc h
	inc d
	ld a,h
	and 7
	jr nz,dbe_1
	ld a,e
	add a,32
	ld e,a
	ld a,d
	jr c,dbe_2
	sub 8
	ld d,a
dbe_2	and 0x18
	or (bgrScr / 256)
	ld h,a
	ld l,e
	djnz dbe_1
	pop de
	ld a,d
	and 0xe0
	ld h,a
	xor d
	rra
	rra
	rra
	and 3
	or 0x18
	or h
	ld d,a
	and 3
	or ((bgrScr + 0x1800) / 256)
	ld h,a
	ld l,e
	ldi
	ldi
	ld bc,30
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	ldi
	ldi
	ret

; map animation (2x2)

; add animation DE to box on cell BC=YX.scr
addAni	ld hl,aniTab
adan1	ld a,32
	exa
	ld a,(hl)
	and a
	jr z,adanY
	inc hl
	inc hl
	inc hl
	inc hl
	inc hl
	exa
	dec a
	jr nz,adan1
	ret
adanY	ld (hl),1
	inc hl
	ld (hl),c
	inc hl
	ld (hl),b
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	call bc2map
	ld a,(hl)
	cp 12
	ret z
	ld (hl),0
	ret

switchAni
	ld hl,aniTab
	ld a,32
swanCYC	exa
	ld a,(hl)
	and a
	jr nz,swanNZ
	inc hl
swan4	inc hl
swan3	inc hl
	inc hl
	inc hl
	exa
	dec a
	jr nz,swanCYC
	ret
swanNZ	inc hl
	ld a,(hl)
	cp c
	jr nz,swan4
	inc hl
	ld a,(hl)
	cp b
	jr nz,swan4
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	dec hl
	dec hl
	dec hl
	dec hl
	ld (hl),1
	or 1
	ret

; call each INT to animate blocks
blkAnim	ld hl,aniTab
	ld de,5
	ld b,32
banCYC	ld a,(hl)
	sub 1
	jr c,banNXT
	ld (hl),a
	call z,banSR
banNXT	add hl,de
	djnz banCYC
	ret

banSR	push hl
	exx
	pop ix
blkaZR	ld c,(ix+1)
	ld b,(ix+2)
	ld e,(ix+3)
	ld d,(ix+4)
	call bc2map
blkaCYC	ld a,(de)
	inc de
	cp 0xf0
	jr nc,blkaCMD
	ld (ix),a
	push af
	ld a,(de)
;	ld (hl),a
	inc de
	ld (ix+3),e
	ld (ix+4),d
	exa
	call bc2scr
	ex de,hl
	exa
	call DrawBox
	pop af
	and a
	jr z,blkaZR
	jr blkaEX
blkaRET	jr nc,blkaCYC
blkaEX	exx
	ret
blkaCMD	push hl
	ld hl,blkaRET
	ex (sp),hl
	push hl
	ld hl,blkaTab
	and 0x0f
	add a,a
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex (sp),hl
blka00	ret

blkaTab	dw blkaF0,blkaF1,blkaF2,blkaF3
	dw blkaF4,blkaF5,blkaF6,blka00
	dw blkaF8,blka00,blka00,blka00
	dw blkaFC,blka00,blkaFE,blkaFF

blkaF0	ex de,hl	; F0,<adr>: jp adr
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex de,hl
bf0_1	and a
	ret

blkaF1	ld a,(de)	; F1,d,<adr> : if ninja in direction d, jump <adr>
	inc de
	push bc
	dec a
	jr z,bf1_up
	dec a
	jr z,bf1_rg
	dec a
	jr z,bf1_dn
	dec a
	jr nz,bf1skip
bf1_lf	dec c
	dec c
bf1l1	call bffTNin
	jr c,bf1nin
	jr bf1skip
bf1_rg	inc c
	inc c
	jr bf1l1
bf1_up	dec b
	dec b
	jr bf1l1
bf1_dn	inc b
	inc b
	jr bf1l1
bf1nin	ld a,(de)
	inc de
	exa
	ld a,(de)
	ld d,a
	exa
	ld e,a
	pop bc
	and a
	ret
bf1skip	inc de
	inc de
	pop bc
	and a
	ret

blkaF2	or 2			; set "moving" on
	ld (ninmovz),a
	ret
	
dirBC	dec a
	jr z,dbc_up
	dec a
	jr z,dbc_rg
	dec a
	jr z,dbc_dn
	dec a
	jr z,dbc_lf
	dec a
	jr z,dbc_rd
	dec a
	jr z,dbc_ld
	dec a
	jr z,dbc_ru
	dec a
	ret nz
dbc_rd	inc b
	inc b
	jr dbc_rg
dbc_ru	dec b
	dec b
dbc_rg	inc c
	inc c
	jr dbc_ex
dbc_ld	inc b
	inc b
	jr dbc_lf
dbc_lu	dec b
	dec b
dbc_lf	dec c
	dec c
	jr dbc_ex
dbc_up	dec b
	dec b
	jr dbc_ex
dbc_dn	inc b
	inc b
dbc_ex	ld a,b
	cp 22
	ret nc
	ld a,c
	cp 32
	ret

blkaF3	ld a,b		; F3,n,<adr> if (up-up) is block n, jp <adr>
	cp 4
	jr c,bf3_s3
	push bc
	push hl
	dec b
	dec b
	dec b
	dec b
	call bc2map
	ld a,(de)
	cp (hl)
	pop hl
	pop bc
	jr nz,bf3_s3
	inc de
	ld a,(de)	; ld de,(de)
	inc de
	exa
	ld a,(de)
	ld d,a
	exa
	ld e,a
	and a
	ret
bf3_s3	inc de
	inc de
	inc de
	and a
	ret
	
blkaF4	ld a,(de)	; F4,d,n: set sprite n to cell in dir d
	inc de
	exa
	ld a,(de)
	inc de
	exa
	push bc
	push de
	push hl
	call dirBC
	jr nc,bf4_ex
	call bc2map
	exa
	ld (hl),a
	exa
	call bc2scr
	ex de,hl
	exa
	call DrawBox
bf4_ex	pop hl
	pop de
	pop bc
	and a
	ret
	
blkaF5	ld a,(de)	; F5,d,<adr> : set animation <adr> for block in dir d
	inc de
	push bc
	push hl
	call dirBC
	jr nc,bf5_r2
;	call bc2map
;	ld a,(de)
;	cp (hl)
;	jr nz,bf5_r3
;	inc de
	ld a,(de)
	ld l,a
	inc de
	ld a,(de)
	ld h,a
	inc de
	push de
	ex de,hl
	ld (ix),1
	call addAni
	ld (ix),0
	pop de
	jr bf5_ret
bf5_r3	inc de
bf5_r2	inc de
	inc de
bf5_ret	pop hl
	pop bc
	and a
	ret

blkaF6	ld a,(de)	; F6,d,n,<adr>: if in dir d is block n then jump adr
	inc de
	push bc
	push hl
	call dirBC
	jr nc,bf5_r3
	call bc2map
	ld a,(de)
	cp (hl)
	jr nz,bf5_r3
	inc de
bf6gadr	ld a,(de)
	ld l,a
	inc de
	ld a,(de)
	ld d,a
	ld e,l
	pop hl
	pop bc
	and a
	ret

blkaF8	ld a,(de)	; F8,d,<adr>: if in dir d is block, stopped ninja, go <adr>
	inc de
	push bc
	push hl
	call dirBC
	jr nc,bf5_r2
	call bc2map
	ld a,(hl)
	ld hl,blkProp
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	and 2
	jr z,bf5_r2
	jr bf6gadr

blkProp	db 0,2,2,2,0,2,2,2,2,2,0,2,0,0,2,2

blkaFC	ld a,(de)	; FC,n: set SFX n
	inc de
	call setSFX
	and a
	ret

blkaFE	ld a,(de)	; FE,d: move to direction 'd'
	inc de
	dec a
	jr z,bfe_up
	dec a
	jr z,bfe_rg
	dec a
	jr z,bfe_dn
	dec a
	jp nz,bf0_1
bfe_lf	and a
	dec c
	ld (ix+1),c
	ld (ix+2),b
	bit 0,c
	ret z
	dec hl
	and a
	ret
bfe_rg	inc c
	ld (ix+1),c
	ld (ix+2),b
	and a
	bit 0,c
	ret nz
	inc hl
	and a
	ret
bfe_up	dec b
	ld (ix+1),c
	ld (ix+2),b
	and a
	bit 0,b
	ret z
	ld a,l
	sub 16
	ld l,a
	sbc a,a
	add a,h
	ld h,a
	and a
	ret
bfe_dn	inc b
	ld (ix+1),c
	ld (ix+2),b
	and a
	bit 0,b
	ret nz
	ld a,l
	add a,16
	ld l,a
	adc a,h
	sub l
	ld h,a
	and a
	ret

blkaFF	ld a,(de)	; FF,d,<adr> check box in direction 'd', if not empty, jump <adr>
	inc de		; FF,0,n - stop and put block n back on map
	dec a
	jr z,bff_up
	dec a
	jr z,bff_rg
	dec a
	jr z,bff_dn
	dec a
	jr z,bff_lf
	dec a		; 5: DR
	jr z,bff_dr
	dec a		; 6: DL
	jr z,bff_dl
	jr bff_stp
bff_dr	push bc
	inc c
	inc c
bffdr1	inc b
	inc b
	call bffCell
	pop bc
	jr nc,bff_yes
	jr bff_no
bff_dl	push bc
	dec c
	dec c
	jr bffdr1
bff_lf	ld a,c
	and a
	jr z,bff_no
	dec c
	dec c
	call bffCell
	inc c
	inc c
	jr nc,bff_yes
	jr bff_no
bff_rg	inc c
	inc c
	call bffCell
	dec c
	dec c
	jr nc,bff_yes
	jr bff_no
bff_up	dec b
	dec b
	call bffCell
	inc b
	inc b
	jr nc,bff_yes
	jr bff_no
bff_dn	inc b
	inc b
	call bffCell
	dec b
	dec b
	jr nc,bff_yes
bff_no	ld a,(de)		; can't move:change addr
	exa
	inc de
	ld a,(de)
	ld d,a
	exa
	ld e,a
	or 2
	ret
bff_yes	inc de			; skip addr
	inc de
	or 2
	ret
bff_stp	ld (ix),0		; wrong dir:stop anim
	ld c,(ix+1)
	ld b,(ix+2)
	call bc2map
	ld a,(de)
	inc de
	ld (hl),a
	ld a,(movcnt)
	sub 1
	ret c
	ld (movcnt),a
	scf
	ret

movTel	push de
	call findTel
	jr z,mtl_1
	push de
	res 0,c
	res 0,b
	call bc2scr
	ex de,hl
	ld a,12
	call DrawBox
	pop de
	push de
	ex de,hl
	call map2bc
	pop hl
	and a
	pop de
	ret
mtl_1	scf
	pop de
	ret

; NC: can move
; C: can't move
bffCell	ld a,31
	cp c
	ret c
	ld a,21
	cp b
	ret c
	push hl
	call bc2map
	ld a,(hl)
	cp 12		; teleport
	jr z,bffcTLP
	and a
	jr nz,bffc_cl
	ld hl,(nin1x)
	call bffNin
	jr c,bffc_nj
	ld hl,(nin2x)
	call bffNin
bffc_nj	pop hl
	ret
bffcTLP	push de
	call findTel
	jr z,bffcTN
	push de
	ld c,(ix+1)
	ld b,(ix+2)
	call bc2scr
	ex de,hl
	xor a
	call DrawBox
	pop hl
	push hl
	call map2bc
	ld (ix+1),c
	ld (ix+2),b
	ld (ix),1
	ld de,animTLP	; set animation: 6 frames redrawing of teleport (else block will erase teleport from screen)
	call addAni
	pop hl
	pop de
	pop af	; pop old HL
	pop af	; pop RET addr
	scf
	ret	; return to blkaRET, wait 1 int
bffcTN	pop de
bffc_cl	pop hl
	scf
	ret

bffTNin	push hl
	ld hl,(nin1x)
	call bffNin
	jr c,bffc_nj
	ld hl,(nin2x)
	call bffNin
	pop hl
	ret

bffNin	ld a,l
	sub c
	jr nc,bffn1
	neg
bffn1	cp 2
	ret nc
	ld a,h
	sub b
	jr nc,bffn2
	neg
bffn2	cp 2
	ret

; boxes animation (1x1)

; add box animation DE on BC=YX with sprite HL
addBox	exx
	ld hl,boxTab
	ld de,14
	ld b,32
adbx_1	ld a,(hl)
	and a
	jr z,adbx_y
	add hl,de
	djnz adbx_1
	exx
	ret
adbx_y	push hl
	push hl
	exx
	pop ix
	ld (ix+1),c
	ld (ix+2),b
	ld (ix+3),e
	ld (ix+4),d
	pop de
	inc de
	inc de
	inc de
	inc de
	inc de
	push bc
	ld bc,9
	ldir
	pop bc
	ld (ix),1
	ret

hideBox	ld hl,boxTab
	ld de,14
	ld b,32
hbxCYC	ld a,(hl)
	and a
	call nz,sbx_sr
	add hl,de
	djnz hbxCYC
	ret

showBox	ld hl,boxTab+31*14	; 31 * 14
	ld de,-14
	ld b,32
	jr hbxCYC

sbx_sr	push hl
	exx
	pop hl
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	inc hl
	inc hl
	ex de,hl
	call bc2scr
;	call addUpd1
	ex de,hl
	ld b,8
sbx_2	ld a,(de)
	ld c,(hl)
	ld (hl),a
	ld a,c
	ld (de),a
	inc hl
	inc d
	djnz sbx_2
	dec d
	toatr d
	ld a,(de)
	ld c,(hl)
	ld (hl),a
	ld a,c
	ld (de),a
	exx
	ret

animBox	ld hl,boxTab
	ld de,14
	ld b,32
abx_z	ld a,(hl)
	sub 1
	jr c,abx_zn
	ld (hl),a
	call z,abx_sr
abx_zn	add hl,de
	djnz abx_z
	ret
	
abx_sr	push hl
	exx
	pop hl
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
abx_ag	ld a,(de)
	inc de
	cp 0xff
	jr z,abx_ff
abx_p	ld (hl),d
	dec hl
	ld (hl),e
	dec hl
	ld (hl),b
	dec hl
	ld (hl),c
	dec hl
	ld (hl),a
	and a
	call z,updBC1
;	call bc2scr
	exx
	ret
abx_00	xor a
	jr abx_p
abx_ff	ld a,(de)
	inc de
	dec a
	jr z,abmv_u
	dec a
	jr z,abmv_r
	dec a
	jr z,abmv_d
	dec a
	jr z,abmv_l
	dec a
	jr z,abmv_dr
	dec a
	jr z,abmv_dl
	dec a
	jr z,abmv_ur
abmv_ul	ld a,c
	and a
	jr z,abx_00
	ld a,b
	and a
	jr z,abx_00
	call updBC1
	dec b
	dec c
abx_sv	call updBC1
	jr abx_ag
abmv_ur	ld a,b
	and a
	jr z,abx_00
	ld a,c
	cp 31
	jr nc,abx_00
	call updBC1
	dec b
	inc c
	jr abx_sv
abmv_dl	ld a,b
	cp 21
	jr nc,abx_00
	ld a,c
	and a
	jr z,abx_00
	call updBC1
	inc b
	dec c
	jr abx_sv
abmv_dr	ld a,b
	cp 21
	jr nc,abx_00
	ld a,c
	cp 31
	jr nc,abx_00
	call updBC1
	inc b
	inc c
	jr abx_sv
abmv_l	ld a,c
	and a
	jr z,abx_00
	call updBC1
	dec c
	jr abx_sv
abmv_r	ld a,c
	cp 31
	jr nc,abx_00
	call updBC1
	inc c
	jr abx_sv
abmv_u	ld a,b
	and a
	jr z,abx_00
	call updBC1
	inc b
	jr abx_sv
abmv_d	ld a,b
	cp 21
	jp nc,abx_00
	call updBC1
	inc b
	jp abx_sv

testBM	ld hl,boxTab
	ld de,14
	ld b,32
tbm_1	ld a,(hl)
	and a
	ret nz
	add hl,de
	djnz tbm_1
	xor a
	ret

boxspd=3

; map animation scripts
aniSldR	db3w 0xf6,1,9,asrBox
asr00	dbbw 0xff,2,aniHSe
	db 0,0,0xfe,2,1,8,0,0,0xfe,2,1,8
	dbw 0xf0,asr00
asrBox	dbbw 0xf3,9,aniHSe
	dbbw 0xf3,14,aniHSe
	dbbw 0xf5,1,aniSBR
	dbw 0xf0,asr00

aniSldL	db3w 0xf6,1,9,aslBox
asl00	dbbw 0xff,4,aniHSe
	db 0,0,0xfe,4,1,8,0,0,0xfe,4,1,8
	dbw 0xf0,aniSldL
aslBox	dbbw 0xf3,9,aniHSe
	dbbw 0xf3,14,aniHSe
	dbbw 0xf5,1,aniSBL
	dbw 0xf0,asl00

aniHSe	db 0xfc,8
	db 0xff,0,8

aniSldU	dbbw 0xff,1,aniVSe
	db 0,0,0xfe,1,1,7,0,0,0xfe,1,1,7
	dbw 0xf0,aniSldU
aniSldD	dbbw 0xff,3,aniVSe
	db 0,0,0xfe,3,1,7,0,0,0xfe,3,1,7
	dbw 0xf0,aniSldD
aniVSe	db 0xff,0,7

; push Xbox
aniBoxL	dbbw 0xff,4,aniBoxE
	db 0xf2
	db 0,0,0xfe,4,1,9,0,0,0xfe,4,1,9
abxDn	dbbw 0xff,3,aniBoxE				; check if empty under box
abxd	dbbw 0xff,3,aniBoxe
	db 0,0,0xfe,3,1,9,0,0,0xfe,3,1,9		; move down
	dbw 0xf0,abxd

aniBoxR	dbbw 0xff,2,aniBoxE
	db 0xf2
	db 0,0,0xfe,2,1,9,0,0,0xfe,2,1,9
	dbw 0xf0,abxDn
aniBoxe	db 0xfc,8
aniBoxE	db 0xff,0,9

; Xbox on slider

aniSBL	dbbw 0xff,4,abhDn
	dbbw 0xff,6,abhDn
	db 0,0,0xfe,4,1,9,0,0,0xfe,4,1,9
	dbw 0xf0,aniSBL

aniSBR	dbbw 0xff,2,abhDn
	dbbw 0xff,5,abhDn
	db 0,0,0xfe,2,1,9,0,0,0xfe,2,1,9
	dbw 0xf0,aniSBR

; push trap-Xbox
aniTBL	dbbw 0xff,4,aniTBE
	db 0,0,0xfe,4,1,9,0,0,0xfe,4,1,9
	db 0xf4,2,4
	dbw 0xf0,abxDn
aniTBE	db 0xff,0,14

aniTBR	dbbw 0xff,2,aniTBE
	db 0,0,0xfe,2,1,9,0,0,0xfe,2,1,9
	db 0xf4,4,4
	dbw 0xf0,abxDn

; fall Trap-box
animTBoxD
	db 4,9
	dbbw 0xff,3,aniTBE
	db 0,0,0xfe,3,1,9,0,0,0xfe,3,1,9
	db 0xf4,1,4
	dbw 0xf0,abxDn
	
	
; ride Xbox on head
animBoxHeadR
	dbbw 0xf1,3,abhrY	; if ninja is down there
	dbw 0xf0,abhDn		; else fall down
abhrY	dbbw 0xff,2,abhDn
	dbbw 0xf8,5,abhBSR
	db 0,0,0xfe,2,1,9
	dbbw 0xf1,2,abhBRN
	db 0,0,0xfe,2,1,9
	dbw 0xf0,animBoxHeadR
abhBSR	;db 0,0,0xfe,2,1,9,0,0,0xfe,2,1,9
	dbw 0xf0,abhDn
abhBRN	db 0,0,0xfe,4,4,9
	dbw 0xf0,abxDn

animBoxHeadL
	dbbw 0xf1,3,abhlY
	dbw 0xf0,abhDn
abhlY	dbbw 0xff,4,abhDn
	dbbw 0xf8,6,abgBSL
	db 0,0,0xfe,4,1,9
	dbbw 0xf1,4,abhBLN
	db 0,0,0xfe,4,1,9
	dbw 0xf0,animBoxHeadL
abgBSL	;db 0,0,0xfe,4,1,9,0,0,0xfe,4,1,9
abhDn	db 3,9
	dbw 0xf0,abxDn
abhBLN	db 0,0,0xfe,2,4,9
	dbw 0xf0,abxDn

animBoxHeadD
	db 5,9
	dbw 0xf0,abxDn

animTLP	dup 6
	db 1,12
	edup
	db 0xff,0,12

;tlpAni	db 1,12
;	dbw 0xf0,tlpAni

; 1x1 boxes animations
fly_ul	db boxspd,0xff,8,boxspd,0xff,8,boxspd,0
fly_ur	db boxspd,0xff,7,boxspd,0xff,7,boxspd,0
fly_dr	db boxspd,0xff,5,boxspd,0xff,5,boxspd,0
fly_dl	db boxspd,0xff,6,boxspd,0xff,6,boxspd,0

boxUL	db 0x00,0x6b,0x43,0x09,0x54,0x3a,0x7a,0x7c,0x47
boxUR	db 0x00,0xbc,0x6a,0xfc,0xea,0x50,0x02,0x04,0x07
boxDL	db 0x7c,0x6a,0x7c,0x28,0x75,0x24,0x52,0x00,0x07
boxDR	db 0x6a,0xf6,0x7a,0x5a,0xfe,0x5a,0x62,0x00,0x07
redBox	db 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x02

boxTab	dup 32
	db 0		; counter
	db 0,0		; x,y
	dw 0		; anim adr
	ds 9		; background / sprite
	edup