; call each INT to move ninjas
ninMove	ld a,(nin1dir)
	and a
	jr z,nmv2
	ld bc,(nin1x)
	call jNMTab
	jr nz,nmv1st
	ld a,1
	ld (ninmovz),a
	ld a,(nindir)
	ld (nin1dir),a
	push bc
	ld bc,(nin1x)
	call updBC
	pop bc
	ld (nin1x),bc
	call updBC
	jr nmv2
nmv1st	xor a
	ld (nin1dir),a
nmv2	ld a,(nin2dir)
	and a
	ret z
	ld bc,(nin2x)
	call jNMTab
	jr nz,nmv2st
	ld a,1
	ld (ninmovz),a
	ld a,(nindir)
	ld (nin2dir),a
	push bc
	ld bc,(nin2x)
	call updBC
	pop bc
	ld (nin2x),bc
	call updBC
	ret
nmv2st	xor a
	ld (nin2dir),a
	ret

jNMTab	ld (nindir),a
	ld a,b
	or c
	and 1
	jr nz,jnm01
	call bc2map
	ld a,(hl)
	cp 15
	call z,chaDir
jnm01	ld a,(nindir)
	ld hl,ninMTab
jumpTab	add a,a
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)

nindir	db 0		; current ninja direction (for checking sliders and box)
ninMTab	dw toRet,nmvup,nmvrg,nmvdn,nmvlf
	dw nmvdr,nmvdl,nmvur,nmvul

nmvdl	call nmvlf
	ret nz
	jr nmvdn
nmvdr	call nmvrg
	ret nz
nmvdn	inc b
	bit 0,b
	ret z
	ld a,b
	cp 20
	jr nc,nmvst
	call bc2map
	ld de,16
	add hl,de
	jr nmu2
nmvul	call nmvlf
	ret nz
	jr nmvup
nmvur	call nmvrg
	ret nz
nmvup	dec b
	bit 0,b
	ret z
	ld a,b
	cp 20
	jr nc,nmvst
	call bc2map
nmu2	ld de,skipTab	; NZ:stop on this block Z:go through
nmu2a	ld a,(de)
	and a
	jr z,nmu2b
	inc de
	cp (hl)
	jr z,nmu2y
	inc de
	inc de
	jr nmu2a
nmu2b	ld a,(hl)
	and a
	ret
nmu2y	ex de,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex de,hl
	push de
	ret
nmvlf	dec c
	bit 0,c
	ret z
	ld a,c
	cp 31
	jr nc,nmvst
	call bc2map
	jr nmu2
nmvrg	inc c
	bit 0,c
	ret z
	ld a,c
	cp 31
	jr nc,nmvst
	call bc2map
	inc hl
	jr nmu2
nmvst	xor a
	ld (nindir),a
	;call setSFX
	or 2
	ret

; in	HL:map.adr of box in front of ninja
;	BC:YX of ninja
;	(nindir):ninja move direction
; out	Z:nija can pass through
;	NZ:ninja stops
skipTab	dbw 4,nmuStar
	dbw 10,nmuRock
	dbw 5,nmuChest
	dbw 7,nmuVSld
	dbw 8,nmuHSld
	dbw 9,nmuBox
	dbw 11,nmuBnc
	dbw 12,nmuTel
	dbw 13,nmuTRok
	dbw 14,nmuTBox
	dbw 15,nmuChan
	db 0

; Rotate box is 'invisible'
nmuChan	xor a
	ret

chaDir	ld a,(nindir)
	ld hl,chaTab
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	ld (nindir),a
	ld a,4
	jp setSFX

chaTab	db 0,2,3,4,1

; Trap box with shuriken under it
nmuTBox	call map2bc
	ld a,(nindir)
	cp 2
	ld de,aniTBR
	jr z,nbox_1
	cp 4
	ret nz
	ld de,aniTBL
	jr nbox_1

; Xbox:push box to 1 cell to left/right
nmuBox	call map2bc	; BC:YX of Xbox
	ld a,(nindir)
	cp 2		; to right
	ld de,aniBoxR
	jr z,nbox_1
	cp 4		; to left
	ret nz
	ld de,aniBoxL
nbox_1	ld a,7
	call setSFX
	ld a,b
	and a
	jr z,nbox_2
	push bc
	push hl
	dec b
	dec b
	call bc2map
	ld a,(hl)
	pop hl
	pop bc
	cp 9
	jr z,nbox_E
	cp 14
	jr z,nbox_E
nbox_2	call addAni
	ld a,(movcnt)
	inc a
	ld (movcnt),a
nbox_E	or 2		; NZ:ninja stop
;	ld (ninmovz),a
	ret

; DE=map.adr of teleport, but not on HL=(map.adr of current teleport)
; Z: not found
; NZ: found
findTel	;dbgstop
	ld e,l
	ld d,h
	ld a,175
ftlp1	exa
	inc de
	ld a,e
	cp (nin1x & 0xff)
	jr nz,ftlp3
	ld de,levBuf
ftlp3	ld a,(de)
	cp 12
	jr z,ftlpY
	exa
	dec a
	jr nz,ftlp1
	ret
ftlpY	or a
	ret

	display "levbuf = ",levBuf

nmuTel	call findTel	; teleport: jump to other
	ret z
	ex de,hl
	call map2bc	; new YX here
	ld a,4
	call setSFX
	xor a		; continue moving
	ret

nmuBnc	ld a,(nindir)	; bounce
	dec a
	xor 2
	inc a
	ld (nindir),a
	ld a,b
	and a
	ret z
	push bc
	dec b
	dec b
	ld a,(nindir)
	inc c
	cp 2
	ld de,animBoxHeadR
	jr z,nbnc1
	dec c
	dec c
	ld de,animBoxHeadL
nbnc1	call switchAni
	jr z,nbnc2
	ld (hl),2
nbnc2	pop bc
	xor a
	ret

nmuHSld	ld a,(nindir)	; push horizontal slider
	cp 2
	jr z,hsRight
	cp 4
	jr z,hsLeft
	or 2
	ret
hsRight	ld de,aniSldR
hsr_1	call map2bc
	push bc
	call addAni
	pop bc
	ld a,7
	call setSFX
	ld a,(movcnt)
	inc a
	ld (movcnt),a
	or 2		; stop after pushing slider
	ld (ninmovz),a
	ret
hsLeft	ld de,aniSldL
	jr hsr_1

nmuVSld	ld a,(nindir)	; push vertical slider
	cp 1
	jr z,vsUp
	cp 3
	ret nz		; NZ:stop
vsDown	ld de,aniSldD
	jr hsr_1
vsUp	ld de,aniSldU
	jr hsr_1

nmuChest
	ld a,(levEnd)
	and a
	ret nz		; NZ: stop
	push hl	; chest: open chest and complete level
	ld (hl),6
	call map2bc
	call bc2scr
	ld a,6
	ex de,hl
	call DrawBox
	xor a
	ld (nin1dir),a
	ld (nin2dir),a
	inc a
	ld (levEnd),a
	pop hl		; NZ:stop
	ret

nmuTRok	push hl		; trap: looks like rock, but with shuriken under it
	push bc
	ld (hl),4
	call map2bc
	call bc2scr
	ld a,4
	ex de,hl
	call DrawBox
	ld a,3
	call setSFX
	pop bc
	pop hl
nmuStar	push hl		; shuriken: go through with blood and death
	push bc
	ld a,1
	call setSFX
	call map2bc
	ld de,fly_ul
	ld hl,redBox
	call addBox
	inc c
	ld de,fly_ur
	ld hl,redBox
	call addBox
	inc b
	ld de,fly_dr
	ld hl,redBox
	call addBox
	dec c
	ld de,fly_dl
	ld hl,redBox
	call addBox
	dec b
	ld a,2
	ld (levEnd),a
	pop bc
	pop hl
	xor a
	ret

nmuRock	push hl		; rock: smash it and go through
	push bc
	push hl
	ld a,3
	call setSFX
	pop hl
	ld (hl),0	; remove rock
	call map2bc
	ld a,b
	and a
	jr z,nmrk1
	ld a,(nindir)	; box will not fall when ninja moving up
	dec a
	jr z,nmrk1
	push bc		; if on top of rock is box
	dec b
	dec b
	call bc2map
	ld a,(hl)
	cp 9		; 9: box
	jr z,nmrkBX
	cp 14		; 14: trap box
	jr nz,nmrk0
nmrkTBX	ld (hl),0
	push de
	ld de,animTBoxD
	jr nmrkZ
nmrkBX	ld (hl),0	; set fall down animation
	push de
	ld de,animBoxHeadD
nmrkZ	call addAni
	pop de
nmrk0	pop bc
nmrk1	call bc2scr
	ex de,hl
	push bc
	xor a
	call DrawBox	; draw empty space here
	pop bc
	ld de,fly_ul	; add 4 boxes - rock pieces
	ld hl,boxUL
	call addBox
	inc c
	ld de,fly_ur
	ld hl,boxUR
	call addBox
	inc b
	ld de,fly_dr
	ld hl,boxDR
	call addBox
	dec c
	ld de,fly_dl
	ld hl,boxDL
	call addBox
	pop bc
	pop hl
	xor a
	ret

;-----------

; start moving : check Xbox on head and set animation
ninHead	ld a,b
	cp 2
	ret c
	dec b
	dec b
	call bc2map
	ld a,(hl)
	cp 9		; Xbox
	ret nz
	ld a,e
	cp 2
	ld de,animBoxHeadR
	jp z,addAni
	cp 3
	ld de,animBoxHeadD
	jp z,addAni
	cp 4
	ret nz
	ld de,animBoxHeadL
	jp addAni

;-----------

SaveBgr1	ld de,nin1bgr
	ld bc,(nin1x)
	jr savBgr
SaveBgr2	ld de,nin2bgr
	ld bc,(nin2x)
savBgr	ld a,c
	cp 32
	ret nc
	call bc2scr
sbgrHL	push hl
	ld b,2
sbgr_1	ld c,8
sbgr_2	ld a,(hl)
	ld (de),a
	inc de
	inc l
	ld a,(hl)
	ld (de),a
	inc de
	dec l
	inc h
	dec c
	jr nz,sbgr_2
	ld a,l
	add a,32
	ld l,a
	jr c,sbgr_3
	ld a,h
	sub 8
	ld h,a
sbgr_3	djnz sbgr_1
	pop hl
	ld a,h
	and 0xe0
	ld c,a
	xor h
	rra
	rra
	rra
	and 3
	or 0x18
	or c
	ld h,a
	ldi
	ldi
	ld bc,30
	add hl,bc
	ldi
	ldi
	ret
	
RestBgr1	ld bc,(nin1x)
	ld de,nin1bgr
	jr rstBgr
RestBgr2	ld bc,(nin2x)
	ld de,nin2bgr
	jp rstBgr

DrawNin1	ld bc,(nin1x)
	ld a,(nin1spr)
	jr drwNin
DrawNin2	ld bc,(nin2x)
	ld a,(nin2spr)
drwNin	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld e,l
	ld d,h
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld de,sprGfx
	add hl,de
	ex de,hl
rstBgr	ld a,c
	cp 32
	ret nc
	call bc2scr
	; call addUpd
rbgrHL	push hl
	ld b,2
dnin_1	ld c,8
dnin_2	ld a,(de)
	ld (hl),a
	inc de
	inc l
	ld a,(de)
	ld (hl),a
	inc de
	dec l
	inc h
	dec c
	jr nz,dnin_2
	ld a,l
	add a,32
	ld l,a
	jr c,dnin_3
	ld a,h
	sub 8
	ld h,a
dnin_3	djnz dnin_1
	pop hl
	ld a,h
	and 0xe0
	ld c,a
	xor h
	rra
	rra
	rra
	and 3
	or 0x18
	or c
	ld h,a
	ex de,hl
	ldi
	ldi
	ld a,e
	add a,30
	ld e,a
	adc a,d
	sub e
	ld d,a
	ldi
	ldi
	ret
