; password input
; out: A=crypted num

passKey	ld hl,0x6000
	ld de,0x6001
	ld bc,0x800
	ld (hl),l
	ldir
	xor a
	ld (pkPos),a
	ld a,'.'
	ld hl,passCod
	ld b,5
pkey1	ld (hl),a
	inc hl
	djnz pkey1

	ld hl,passTxt
	ld de,0x602B
	call prnText
	ld hl,passT2
	ld de,0x604B
	call prnText
	call otxtE

pkey2	ld hl,passCod
	ld de,0x484D
	call prnText
	call noKey
	ld a,(pkPos)
	cp 5
	jr nc,pkCHK
pkey3	halt
	call getKey
	and a
	jr z,pkey3
	cp '0'
	jr z,pkDEL
	cp 13
	jp z,pkENT
	cp 'A'
	jr c,pkey3
	ld c,a
	ld a,(pkPos)
	cp 5
	jr nc,pkey3
	inc a
	ld (pkPos),a
	ld hl,passCod-1
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld (hl),c
	jr pkey2
pkDEL	ld a,(pkPos)
	sub 1
	jr c,pkey3
	ld (pkPos),a
	ld hl,passCod
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld (hl),'.'
	jr pkey2
pkCHK	ld hl,passCod
	ld bc,0x0400
pkch1	ld a,(hl)
	and 15
	add a,c
	ld c,a
	inc hl
	djnz pkch1
	ld a,c
	and 15
	add a,'A'
	cp (hl)
	jr nz,pkey3	; wrong checksum
	;dbgstop
	ld hl,passCod
	ld c,0
	call popBits
	rla
	rla
	rla
	rla
	rla
	rla
	ld c,a
	inc hl
	call popBits
	rla
	rla
	rla
	rla
	or c
	ld c,a
	inc hl
	call popBits
	rla
	rla
	or c
	ld c,a
	inc hl
	call popBits
	or c
	ld c,a
	call noKey
	ld a,c
	cp maxlev
	jp nc,pkey3
	ld (curLev),a
	ld hl,confTxt
	ld de,0x6008
	call prnText
	call ocodE
	call noKey
	call waitKey
	jp noKey
pkENT	xor a
	ld (curLev),a
	jp noKey

; password generator
; in: HL=buf (5 bytes), A=number to crypt

genPass	call getBit6
	ld (hl),a
	and 15
	ld c,a
	inc hl
	ld a,(curLev)
	call getBit4
	ld (hl),a
	and 15
	add a,c
	ld c,a
	inc hl
	ld a,(curLev)
	call getBit2
	ld (hl),a
	and 15
	add a,c
	ld c,a
	inc hl
	ld a,(curLev)
	call getBit0
	ld (hl),a
	and 15
	add a,c
	inc hl
	and 15
	add a,'A'
	ld (hl),a
	ret

pkPos	db 0
passTxt	db "TYPE CODE",0
passT2	db "[ "
passCod db "..... ]",0
confTxt	db "Jump to level ",1,0

popBits	ld a,(hl)
	sub 'A'
	ld e,a
	rra
	rra
	xor e
	and 3
	ret

getKey	ld bc,0x7ffe
	ld hl,gkTab
gkey1	in a,(c)
	ld d,5
gkey2	rra
	jr nc,gkYES
	inc hl
	dec d
	jr nz,gkey2
	rr b
	jr c,gkey1
	xor a
	ret
gkYES	ld a,(hl)
	and a
	ret

; 1	SS
; 2	CS
; 13	Enter
; 32	Space

gkTab	db 0x20,0x01,"MNB"
	db 0x0d,"LKJH"
	db "POIUY"
	db "09876"
	db "12345"
	db "QWERT"
	db "ASDFG"
	db 0x02,"ZXCV"
