; in: HL=adr of text (max 32 chars, terminated by 0)
outText	push hl
	ld hl,0x6000
	ld de,0x6001
	ld bc,0x800
	ld (hl),l
	ldir
	pop hl
	push hl
	ld c,0xff
otxt1	inc c
	ld a,(hl)
	inc hl
	and a
	jr nz,otxt1
	ld a,32
	sub c
	rra
	and 0x1f
	or 0x20
	ld e,a
	ld d,0x60
	pop hl
	call otxtP
otxtE	ld hl,0x481f
	ld de,0x591f
otxe1	halt
	ld bc,0x6000
	push de
	push hl
otxe2	ld a,(bc)
	ld (hl),a
	inc b
	inc h
	ld a,h
	and 7
	jr nz,otxe2
	ld a,7
	ld (de),a
	ld a,e
	add a,32
	ld e,a
	ld h,0x48
	ld a,l
	add a,32
	ld l,a
	ld b,0x60
	ld a,c
	add a,32
	ld c,a
	cp 0x80
	jr c,otxe2
	ld a,c
	and 31
	ld c,a
	ld a,e
	and 31
	ld e,a
	ld a,l
	and 31
	ld l,a
	inc c
	inc e
	inc l
	ld a,l
	and 31
	jr nz,otxe2
	pop hl
	pop de
	dec l
	dec e
	ld a,l
	and 31
	cp 31
	jr nz,otxe1
	ret

otxtP	ld a,(hl)	; HL:text adr, DE:scr.adr
	and a
	ret z
	inc hl
	push hl
	sub 32
;	jr z,otxtSP
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fntx2
	add hl,bc
	push de
	ld b,2
otxt2	ld c,8
otxt3	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	dec c
	jr nz,otxt3
	ld a,e
	add a,32
	ld e,a
	ccf
	sbc a,a
	and 0xf8
	add a,d
	ld d,a
	djnz otxt2
	pop de
otxtSP	pop hl
	inc e
	jr otxtP

outCode	ld hl,codeBuf
	ld a,(curLev)
	call genPass
	ld de,0x600A	; print text in buf
	ld hl,codeTxt
	call prnText
ocodE	ld bc,0x601f	; scroll out text
ocod1	halt
	push bc
	ld hl,0x4880
	ld de,0x5980
ocod2	ld a,(bc)
	ld (hl),a
	inc h
	inc b
	ld a,h
	and 7
	jr nz,ocod2	
	ld b,0x60
	ld h,0x48
	ld a,0x46
	ld (de),a
	set 5,e
	xor a
	ld (de),a
	res 5,e
	inc l
	inc e
	inc c
	ld a,c
	and 0x1f
	jr nz,ocod2
	pop bc
	ld a,c
	dec c
	and a
	jr nz,ocod1
	ret

getBit6	rra
	rra
getBit4	rra
	rra
getBit2	rra
	rra
getBit0	and 3
	ld e,a
	ld a,r
	and 0x0c
	or e
	ld e,a
	rra
	rra
	and 3
	xor e
	add a,'A'
	ret

codeTxt	db "code  "
codeBuf	db "00000",0

prnText	;dbgstop
	ld a,(hl)
	and a
	ret z
	inc hl
	sub 32
	jr c,prtCOM
	call prtChar
	jr prnText
prtCOM	push hl
	ld hl,prnText
	ex (sp),hl
	push hl
	ld hl,prtTab
	and 31
	ld c,a
prtc1	ld a,(hl)
	and a
	jr z,prtcEX
	inc hl
	cp c
	jr z,prtcJP
	inc hl
	inc hl
	jr prtc1
prtcEX	pop hl
	ret
prtcJP	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex (sp),hl
	ret

prtChar	push hl
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fntx1
	add hl,bc
	ld b,8
	ld c,d
prt2	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	djnz prt2
	ld d,c
	pop hl
	inc e
	ret

prtTab	dbw 1,prt01
	db 0

prt01	push hl
	ld l,0
	ld a,(curLev)
	inc a
	ld c,100
	call prtDig
	ld c,10
	call prtDig
	pop hl
	add a,16
	jp prtChar
	
prtDig	ld b,15
pdig1	inc b
	sub c
	jr nc,pdig1
	add a,c
	push af
	ld a,b
	cp 16
	jr nz,pdigNZ
	inc l
	dec l
	jr z,pdigZ
pdigNZ	ld l,1
	call prtChar
pdigZ	pop af
	ret

levFail	db "LEVEL FAILED",0
levComp	db "LEVEL COMPLETED",0
gamComp	db "WELL DONE",0
levText	db "Level ",1,0

fntx1	incbin "bin/font x1.bin"
fntx2	incbin "bin/font x2.bin"